.\" Copyright (c) 1994
.\"	Jan-Simon Pendry
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)undelete.2	8.4 (Berkeley) 10/18/94
.\" $FreeBSD: src/lib/libc/sys/undelete.2,v 1.17 2006/01/22 19:49:37 truckman Exp $
.\"
.Dd January 22, 2006
.Dt UNDELETE 2
.Os
.Sh NAME
.Nm undelete
.Nd attempt to recover a deleted file
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In unistd.h
.Ft int
.Fn undelete "const char *path"
.Sh DESCRIPTION
The
.Fn undelete
system call attempts to recover the deleted file named by
.Fa path .
Currently, this works only when the named object
is a whiteout in a union file system.
The system call removes the whiteout causing
any objects in a lower layer of the
union stack to become visible once more.
.Pp
Eventually, the
.Fn undelete
functionality may be expanded to other file systems able to recover
deleted files such as the log-structured file system.
.Sh RETURN VALUES
.Rv -std undelete
.Sh ERRORS
The
.Fn undelete
succeeds unless:
.Bl -tag -width Er
.It Bq Er ENOTDIR
A component of the path prefix is not a directory.
.It Bq Er ENAMETOOLONG
A component of a pathname exceeded 255 characters,
or an entire path name exceeded 1023 characters.
.It Bq Er EEXIST
The path does not reference a whiteout.
.It Bq Er ENOENT
The named whiteout does not exist.
.It Bq Er EACCES
Search permission is denied for a component of the path prefix.
.It Bq Er EACCES
Write permission is denied on the directory containing the name
to be undeleted.
.It Bq Er ELOOP
Too many symbolic links were encountered in translating the pathname.
.It Bq Er EPERM
The directory containing the name is marked sticky,
and the containing directory is not owned by the effective user ID.
.It Bq Er EINVAL
The last component of the path is
.Ql .. .
.It Bq Er EIO
An I/O error occurred while updating the directory entry.
.It Bq Er EROFS
The name resides on a read-only file system.
.It Bq Er EFAULT
The
.Fa path
argument
points outside the process's allocated address space.
.El
.Sh SEE ALSO
.Xr unlink 2
.Sh HISTORY
The
.Fn undelete
system call first appeared in
.Bx 4.4 Lite .
